/***********************************************************************/
/*                                                                     */
/*                         Call/cc for ocamlc                          */
/*                                                                     */
/*            Xavier Leroy, projet Cristal, INRIA Rocquencourt         */
/*                                                                     */
/*  Copyright 2005 Institut National de Recherche en Informatique et   */
/*  en Automatique.  All rights reserved.  This file is distributed    */
/*  under the terms of the GNU Library General Public License, with    */
/*  the special exception on linking described in file LICENSE.        */
/*                                                                     */
/***********************************************************************/

/* $Id: callcc.c,v 1.2 2005/10/05 08:16:49 xleroy Exp $ */

#include <string.h>
#include <alloc.h>
#include <memory.h>
#include <mlvalues.h>
#include <stacks.h>

value duplicate_stack(unit)
     value unit;
{
  mlsize_t nentries, size, i;
  value block;
  value * p, * q;

  nentries = stack_high - extern_sp;
  size = nentries + 1;
  if (size < Max_young_wosize) {
    block = alloc(size, 0);
    memcpy(&Field(block, 0), extern_sp, nentries * sizeof(value));
  } else {
    block = alloc_shr(size, 0);
    for (i = 0; i < nentries; i++)
      initialize(&Field(block, i), extern_sp[i]);
  }
  Field(block, nentries) = Val_long(trapsp - extern_sp);
  p = trapsp;
  while (p < stack_high) {
    q = Trap_link(p);
    Field(block, p - extern_sp + 1) = Val_long(q - extern_sp);
    p = q;
  }
  return block;
}

value reinstall_stack(block_res)
     value block_res;
{
  value block = Field(block_res, 0);
  value res = Field(block_res, 1);
  mlsize_t nentries, size;
  value * p;

  size = Wosize_val(block);
  nentries = size - 1;
  Assert (nentries <= stack_high - stack_low);
  extern_sp = stack_high - nentries;
  bcopy(&Field(block, 0), extern_sp, nentries * sizeof(value));
  trapsp = extern_sp + Long_val(Field(block, nentries));
  for (p = trapsp; p < stack_high; p = Trap_link(p)) {
    Trap_link(p) = extern_sp + Long_val((value) Trap_link(p));
  }
  return res;
}

